Description: Remove -s option from install sections in Makefiles.
Symptom:     The s390-tools debug rpm is empty.
Problem:     Because we stripped the binaries in the install step, the
             debug info is not available.
Solution:    Remove -s option. Binaries are stripped in the rpm build process.
---
 cpuplugd/Makefile              |    2 +-
 dasdfmt/Makefile               |    2 +-
 dasdinfo/Makefile              |    2 +-
 dasdview/Makefile              |    2 +-
 fdasd/Makefile                 |    2 +-
 ip_watcher/Makefile            |    2 +-
 ipl_tools/Makefile             |    2 +-
 mon_tools/Makefile             |    4 ++--
 osasnmpd/osasnmpd-2.4/Makefile |    2 +-
 osasnmpd/osasnmpd-2.6/Makefile |    2 +-
 qetharp/Makefile               |    4 ++--
 tape390/Makefile               |    4 ++--
 tunedasd/src/Makefile          |    2 +-
 vmconvert/Makefile             |    2 +-
 vmcp/Makefile                  |    2 +-
 vmur/Makefile                  |    2 +-
 zdump/Makefile                 |    2 +-
 zipl/src/Makefile              |    2 +-
 18 files changed, 21 insertions(+), 21 deletions(-)

Index: s390-tools-sles11/cpuplugd/Makefile
===================================================================
--- s390-tools-sles11.orig/cpuplugd/Makefile
+++ s390-tools-sles11/cpuplugd/Makefile
@@ -18,7 +18,7 @@ clean:
 	rm -f cpuplugd
 
 install: all
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 cpuplugd $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 cpuplugd $(USRSBINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.8 $(MANDIR)/man8
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 man/cpuplugd.conf.5 $(MANDIR)/man5
 
Index: s390-tools-sles11/dasdfmt/Makefile
===================================================================
--- s390-tools-sles11.orig/dasdfmt/Makefile
+++ s390-tools-sles11/dasdfmt/Makefile
@@ -11,7 +11,7 @@ dasdfmt: ../libvtoc/vtoc.o dasdfmt.c das
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdfmt $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdfmt.8  $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/dasdinfo/Makefile
===================================================================
--- s390-tools-sles11.orig/dasdinfo/Makefile
+++ s390-tools-sles11/dasdinfo/Makefile
@@ -17,7 +17,7 @@ dasdinfo: $(LIB_OBJECTS) dasdinfo.c
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdinfo $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdinfo.8  $(MANDIR)/man8
 
 clean:
Index: s390-tools-sles11/dasdview/Makefile
===================================================================
--- s390-tools-sles11.orig/dasdview/Makefile
+++ s390-tools-sles11/dasdview/Makefile
@@ -17,7 +17,7 @@ dasdview: $(LIB_OBJECTS) dasdview.c dasd
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 dasdview $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 dasdview $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 dasdview.8  $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/fdasd/Makefile
===================================================================
--- s390-tools-sles11.orig/fdasd/Makefile
+++ s390-tools-sles11/fdasd/Makefile
@@ -11,7 +11,7 @@ fdasd: ../libvtoc/vtoc.o fdasd.c fdasd.h
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 fdasd $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 fdasd $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 fdasd.8  $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/ip_watcher/Makefile
===================================================================
--- s390-tools-sles11.orig/ip_watcher/Makefile
+++ s390-tools-sles11/ip_watcher/Makefile
@@ -13,7 +13,7 @@ install: ip_watcher.pl xcec-bridge start
 	chown $(OWNER).$(GROUP) $(USRSBINDIR)/start_hsnc.sh; \
 	chmod 755 $(USRSBINDIR)/start_hsnc.sh; \
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 ip_watcher.pl $(USRSBINDIR)
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 xcec-bridge $(USRSBINDIR)
 
 xcec-bridge: xcec-bridge.c
 	$(CC) $(CFLAGS) -o xcec-bridge xcec-bridge.c
Index: s390-tools-sles11/ipl_tools/Makefile
===================================================================
--- s390-tools-sles11.orig/ipl_tools/Makefile
+++ s390-tools-sles11/ipl_tools/Makefile
@@ -24,7 +24,7 @@ clean:
 	rm -rf lsshut
 
 install: all
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 chreipl $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 chreipl $(USRSBINDIR)
 	ln -f -s chreipl $(USRSBINDIR)/lsreipl
 	ln -f -s chreipl $(USRSBINDIR)/chshut
 	ln -f -s chreipl $(USRSBINDIR)/lsshut
Index: s390-tools-sles11/mon_tools/Makefile
===================================================================
--- s390-tools-sles11.orig/mon_tools/Makefile
+++ s390-tools-sles11/mon_tools/Makefile
@@ -12,9 +12,9 @@ mon_procd: mon_procd.c mon_procd.h
 	$(CC) $(CFLAGS) -o mon_procd mon_procd.c
 
 install: all
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 mon_fsstatd $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 mon_fsstatd $(USRSBINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 mon_fsstatd.8  $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 mon_procd $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 mon_procd $(USRSBINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 mon_procd.8 $(MANDIR)/man8
 
 clean:
Index: s390-tools-sles11/osasnmpd/osasnmpd-2.4/Makefile
===================================================================
--- s390-tools-sles11.orig/osasnmpd/osasnmpd-2.4/Makefile
+++ s390-tools-sles11/osasnmpd/osasnmpd-2.4/Makefile
@@ -8,7 +8,7 @@ osasnmpd-2.4: $(OBJS)
 	$(CC) -o osasnmpd-2.4 $(OBJS) $(LIBS) 
 
 install: osasnmpd-2.4
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 osasnmpd-2.4 $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 osasnmpd-2.4 $(USRSBINDIR)
 
 clean:
 	rm -f $(OBJS) osasnmpd-2.4 core
Index: s390-tools-sles11/osasnmpd/osasnmpd-2.6/Makefile
===================================================================
--- s390-tools-sles11.orig/osasnmpd/osasnmpd-2.6/Makefile
+++ s390-tools-sles11/osasnmpd/osasnmpd-2.6/Makefile
@@ -8,7 +8,7 @@ osasnmpd-2.6: $(OBJS)
 	$(CC) $(CFLAGS) -o osasnmpd-2.6 $(OBJS) $(LIBS) 
 
 install: osasnmpd-2.6
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 osasnmpd-2.6 $(USRSBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 osasnmpd-2.6 $(USRSBINDIR)
 
 clean:
 	rm -f $(OBJS) osasnmpd-2.6 core
Index: s390-tools-sles11/qetharp/Makefile
===================================================================
--- s390-tools-sles11.orig/qetharp/Makefile
+++ s390-tools-sles11/qetharp/Makefile
@@ -14,8 +14,8 @@ qetharp-2.6: qetharp26.c
 install: all
 	$(INSTALL) -d -m 755 $(MANDIR)/man8 $(BINDIR)
 	$(INSTALL) -m 755 qetharp $(BINDIR)
-	$(INSTALL) -s -m 755 qetharp-2.4 $(BINDIR)
-	$(INSTALL) -s -m 755 qetharp-2.6 $(BINDIR)
+	$(INSTALL) -m 755 qetharp-2.4 $(BINDIR)
+	$(INSTALL) -m 755 qetharp-2.6 $(BINDIR)
 	$(INSTALL) -m 644 qetharp.8 $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/tape390/Makefile
===================================================================
--- s390-tools-sles11.orig/tape390/Makefile
+++ s390-tools-sles11/tape390/Makefile
@@ -13,10 +13,10 @@ tape390_crypt: tape390_crypt.c tape390_c
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 tape390_display $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 tape390_display $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 tape390_display.8 \
 		$(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 tape390_crypt $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 tape390_crypt $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 tape390_crypt.8 \
 		$(MANDIR)/man8
 
Index: s390-tools-sles11/tunedasd/src/Makefile
===================================================================
--- s390-tools-sles11.orig/tunedasd/src/Makefile
+++ s390-tools-sles11/tunedasd/src/Makefile
@@ -15,7 +15,7 @@ tunedasd: $(objects)
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR)
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 tunedasd $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 tunedasd $(BINDIR)
 
 clean:
 	rm -f *.o tunedasd
Index: s390-tools-sles11/vmconvert/Makefile
===================================================================
--- s390-tools-sles11.orig/vmconvert/Makefile
+++ s390-tools-sles11/vmconvert/Makefile
@@ -16,7 +16,7 @@ vmconvert: $(OBJS)
 
 install: all
 	$(INSTALL) -d -m 755 $(USRBINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 vmconvert $(USRBINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 vmconvert $(USRBINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 vmconvert.8  $(MANDIR)/man8
 
 clean:
Index: s390-tools-sles11/vmcp/Makefile
===================================================================
--- s390-tools-sles11.orig/vmcp/Makefile
+++ s390-tools-sles11/vmcp/Makefile
@@ -11,7 +11,7 @@ vmcp: vmcp.c vmcp.h ../include/zt_common
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 vmcp $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 vmcp $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 vmcp.8 $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/vmur/Makefile
===================================================================
--- s390-tools-sles11.orig/vmur/Makefile
+++ s390-tools-sles11/vmur/Makefile
@@ -10,7 +10,7 @@ vmur: vmur.c vmur.h
 
 install: all
 	$(INSTALL) -d -m 755 $(BINDIR) $(MANDIR)/man8
-	$(INSTALL) -s -g $(GROUP) -o $(OWNER) -m 755 vmur $(BINDIR)
+	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 755 vmur $(BINDIR)
 	$(INSTALL) -g $(GROUP) -o $(OWNER) -m 644 vmur.8 \
 		$(MANDIR)/man8
 
Index: s390-tools-sles11/zdump/Makefile
===================================================================
--- s390-tools-sles11.orig/zdump/Makefile
+++ s390-tools-sles11/zdump/Makefile
@@ -11,7 +11,7 @@ zgetdump: zgetdump.c
 
 install: all
 	$(INSTALL) -d -m 755 $(MANDIR)/man8 $(BINDIR)
-	$(INSTALL) -s -m 755 zgetdump $(BINDIR)
+	$(INSTALL) -m 755 zgetdump $(BINDIR)
 	$(INSTALL) -m 644 zgetdump.8 $(MANDIR)/man8 
 
 clean:
Index: s390-tools-sles11/zipl/src/Makefile
===================================================================
--- s390-tools-sles11.orig/zipl/src/Makefile
+++ s390-tools-sles11/zipl/src/Makefile
@@ -20,7 +20,7 @@ zipl: ../boot/data.c $(objects)
 install: all
 	@echo $(INSTALL)
 	$(INSTALL) -d -m 755 $(BINDIR)
-	$(INSTALL) -s -c zipl $(BINDIR)
+	$(INSTALL) -c zipl $(BINDIR)
 
 clean:
 	rm -f *.o zipl